<?
require_once('includes/common.php');
require_once('includes/Project.php');
require_once('includes/Task.php');
require_once('includes/TaskActivity.php');

checkLogin();

$activity = new TaskActivity();
$_REQUEST['detail'] = strtolower(substr($_REQUEST['detail'],0,1)) == "y" ? TRUE : FALSE;

if($_REQUEST['company_id']){
	if(!$loggedin_user->hasRight('admin') && !$loggedin_user->hasRight('accounting')){
		if($loggedin_user->company_id != $_REQUEST['company_id']){
			fatal_error('You do not have access to view this company!');
		}
	}
	$title = "for Company";
	$field_header = 'Billed';
	$field = 'invoice_id';
	$url = $_SERVER['PHP_SELF']."?company_id=".$_REQUEST['company_id']."&unbilled=".$_REQUEST['unbilled']."&";
	$_REQUEST['unbilled'] = strtolower(substr($_REQUEST['unbilled'],0,1)) == "y" ? TRUE : FALSE;
	$activities = $activity->getActivitiesForCompany($_REQUEST['company_id'], $_REQUEST['unbilled']);
	if($activities === FALSE){
		$error_msg .= "Could not retrieve Activity List for Company ID ".$_REQUEST['company_id']."!\n";
		debug_message($activity->getLastError());
	}
}else if($_REQUEST['invoice']){
	$title = "for Invoice Number ".$_REQUEST['invoice'];
	$field_header = 'Billed';
	$field = 'invoice';
	$url = $_SERVER['PHP_SELF']."?invoice=".$_REQUEST['invoice']."&";
	$invoice = new Invoice();
	if($invoice->get($_REQUEST['invoice']) === FALSE){
		$error_msg .= "Could not get activities for invoice!";
		debug_message($invoice->getLastError());
	}
	
	if(!$loggedin_user->hasRight('admin') && !$loggedin_user->hasRight('accounting')){
		if($loggedin_user->company_id != $invoice->company_id){
			fatal_error('You do not have access to view this invoice!');
		}
	}
	
	$activities = $activity->getActivitiesForCompany(0, TRUE, $_REQUEST['invoice']);
	if($activities === FALSE){
		$error_msg .= "Could not retrieve Activity List for Invoice ".$_REQUEST['invoice']."!\n";
		debug_message($activity->getLastError());
	}
}else if($_REQUEST['check']){
	$title = "for Check Number ".$_REQUEST['check'];
	$field_header = 'Paid';
	$field = 'check';
	$url = $_SERVER['PHP_SELF']."?check=".$_REQUEST['check']."&";
	$check = new Check();
	if($check->getByNumber($_REQUEST['check']) === FALSE){
		$error_msg .= "Could not retrieve Activity List for Check ".$_REQUEST['check']."!\n";
		debug_message($check->getLastError());
	}
	if(!$loggedin_user->hasRight('admin') && !$loggedin_user->hasRight('accounting')){
		if($loggedin_user->id != $check->user_id){
			fatal_error('You do not have access to view this check!');
		}
	}
	
	$activities = $check->getActivities();
	if($activities === FALSE){
		$error_msg .= "Could not retrieve Activity List for Check ID ".$_REQUEST['check']."!\n";
		debug_message($check->getLastError());
	}
	$commissions = $check->getCommissions($_REQUEST['check']);
	if($commissions === FALSE){
		$error_msg .= "Could not retrieve Commission List for Check ID ".$check->id."!\n";
		debug_message($check->getLastError());
	}	
	
	
}elseif($_REQUEST['user_id']){
	$title = "for User";
	$field_header = 'Paid';
	$field = 'check';
	$url = $_SERVER['PHP_SELF']."?user_id=".$_REQUEST['user_id']."&unpaid=".$_REQUEST['unpaid']."&";
	$_REQUEST['unpaid'] = strtolower(substr($_REQUEST['unpaid'],0,1)) == "y" ? TRUE : FALSE;
	
	if(!$loggedin_user->hasRight('admin') && !$loggedin_user->hasRight('accounting')){
		if($loggedin_user->id != $_REQUEST['user_id']){
			fatal_error('You do not have access to view this users activities!');
		}
	}
	
	$user = new User();
	$activities = $user->getActivities($_REQUEST['user_id'], $_REQUEST['unpaid']);
	if($activities === FALSE){
		$error_msg .= "Could not retrieve Activity List for User ID ".$_REQUEST['user_id']."!\n";
		debug_message($user->getLastError());
	}
	$commissions = $user->getCommissions($_REQUEST['user_id']);
	if($commissions === FALSE){
		$error_msg .= "Could not retrieve Commission List for User ID ".$user->id."!\n";
		debug_message($user->getLastError());
	}	
}else{
	$display_form = TRUE;
	$title = 'Activity Log';
}

$total_time = 0;

require('header.php') ?>
<?
if($display_form){ ?>
<FORM ACTION="<?= $_SERVER['PHP_SELF'] ?>" METHOD="GET">
<INPUT NAME="referrer" TYPE="hidden" VALUE="<?= $_REQUEST['referrer'] ?>">
<TABLE BORDER="0" CELLSPACING="0" CELLPADDING="0" CLASS="form_table">
<TR>
	<TD COLSPAN="2" CLASS="form_header_cell"><?= $title ?></TD>
</TR>
<TR>
	<TD CLASS="form_field_header_cell">Invoice Number:</TD>
	<TD CLASS="form_field_cell"><INPUT TYPE="text" CLASS="input_text" NAME="invoice" SIZE="10"></TD>
</TR>
<TR>
	<TD CLASS="form_field_header_cell">Check Number:</TD>
	<TD CLASS="form_field_cell"><INPUT TYPE="text" CLASS="input_text" NAME="check" SIZE="10"></TD>
</TR>
<TR>
	<TD COLSPAN="2" CLASS="form_field_cell">
		<DIV ALIGN="right"><INPUT TYPE="submit" NAME="save" CLASS="button" VALUE="View"></DIV>
	</TD>
</TR>
</TABLE>
</FORM>
<?
}else{ //else if display_form 
?>
<FORM ACTION="<?= $_SERVER['PHP_SELF'] ?>" METHOD="POST" NAME="chk">
<INPUT TYPE="hidden" NAME="company_id" VALUE="<?= $_REQUEST['company_id'] ?>">
<INPUT TYPE="hidden" NAME="user_id" VALUE="<?= $_REQUEST['user_id'] ?>">
<INPUT TYPE="hidden" NAME="invoice" VALUE="<?= $_REQUEST['invoice'] ?>">
<INPUT TYPE="hidden" NAME="detail" VALUE="<?= $_REQUEST['detail'] ?>">
<TABLE BORDER="0" CELLSPACING="0" CELLPADDING="0" CLASS="dg_table">
	<TR>
		<TD COLSPAN="9" CLASS="form_header_cell">
			<TABLE BORDER="0" CELLPADDING="0" CELLSPACING="0" WIDTH="100%">
				<TR>
					<TD>Activities <?= $title ?></TD>
					<TD ALIGN="right">
						Detail:&nbsp;
						<A CLASS="<?= $_REQUEST['detail'] == TRUE ? "link3" : "link1" ?>" HREF="<?= $url."detail=y" ?>">Yes</A>&nbsp;|&nbsp;
						<A CLASS="<?= $_REQUEST['detail'] == TRUE ? "link1" : "link3" ?>" HREF="<?= $url."detail=n" ?>">No</A>
					</TD>
				</TR>
			</TABLE>
		</TD>
	</TR>
	<TR>
		<TD CLASS="dg_header_cell"><A CLASS="link1" HREF="" onClick="return sortTable('bodyId', 0, 1, false)">Project</A></TD>
		<TD CLASS="dg_header_cell"><A CLASS="link1" HREF="" onClick="return sortTable('bodyId', 1, 0, false)">Task</A></TD>
		<TD CLASS="dg_header_cell"><A CLASS="link1" HREF="" onClick="return sortTable('bodyId', 2, 0, false)">Start</A></TD>
		<TD CLASS="dg_header_cell"><A CLASS="link1" HREF="" onClick="return sortTable('bodyId', 3, 0, false)">End</A></TD>
		<TD CLASS="dg_header_cell"><A CLASS="link1" HREF="" onClick="return sortTable('bodyId', 4, 0, false)">Time Spent</A></TD>
<? if($loggedin_user->hasRight('admin') || $loggedin_user->hasRight('accounting')){ ?>
		<TD CLASS="dg_header_cell"><A CLASS="link1" HREF="" onClick="return sortTable('bodyId', 5, 0, false)">Cost</A></TD>
		<TD CLASS="dg_header_cell"><A CLASS="link1" HREF="" onClick="return sortTable('bodyId', 5, 0, false)">Price</A></TD>
<? } ?>
		<TD CLASS="dg_header_cell"><A CLASS="link1" HREF="" onClick="return sortTable('bodyId', 6, 0, false)"><?= $field_header ?></A></TD>
		<TD CLASS="dg_header_cell">Options</TD>
	</TR>
	<TBODY ID="bodyId">
<? for($i = 0; $i < count($activities); $i++){
		$task = $activities[$i]->getTask();

		$act_time = ($activities[$i]->end_ts>0 &&  $activities[$i]->start_ts>0 ? $activities[$i]->end_ts - $activities[$i]->start_ts : 0);
		$total_time += $act_time;
		$total_cost += $activities[$i]->cost;
		$total_price += $activities[$i]->price;
		$activities[$i]->stripSlashes();
		//var_dump($activities[$i]);
?>
	<TR onMouseOver="this.style.backgroundColor ='#CCCCCC'" onMouseOut="this.style.backgroundColor ='#FFFFFF'">
		<TD CLASS="dg_data_cell_1"><?= $activities[$i]->project_name ?></TD>
		<TD CLASS="dg_data_cell_1"><?= $activities[$i]->task_name ?></TD>
		<TD CLASS="dg_data_cell_1"><?= $activities[$i]->start_ts>0 ? date("n/j/y H:i", $activities[$i]->start_ts) :  "" ?></TD>
		<TD CLASS="dg_data_cell_1"><?= $activities[$i]->end_ts>0 ? date("n/j/y H:i", $activities[$i]->end_ts) :  "" ?></TD>
		<TD CLASS="dg_data_cell_1"><?= $act_time>0 ? formatLengthOfTime($act_time) :  "" ?></TD>
<? if($loggedin_user->hasRight('admin') || $loggedin_user->hasRight('accounting')){ ?>
		<TD CLASS="dg_data_cell_1">$<?= number_format($activities[$i]->cost, 2) ?></TD>
		<TD CLASS="dg_data_cell_1">$<?= number_format($activities[$i]->price, 2) ?></TD>
<? } ?>
		<TD CLASS="dg_data_cell_1"><?= $activities[$i]->$field > 0  ?  $activities[$i]->$field :  "No" ?></TD>
		<TD CLASS="dg_data_cell_1">&nbsp;
			<A CLASS="link1" HREF="task_activity.php?mode=edit&id=<?= $activities[$i]->id ?>"><img src="images/edit.gif" width="16" height="16" alt="Edit" border="0" /></A>&nbsp;|&nbsp;
			<A CLASS="link1" HREF="task_activity.php?mode=delete&id=<?= $activities[$i]->id ?>"><img src="images/delete.gif" width="16" height="16" alt="" border="0" /></A>&nbsp;
		</TD>
	</TR>
<? if($_REQUEST['detail']){?>
	<TR>
		<TD COLSPAN="9" CLASS="dg_data_cell_1"><?= nl2br($activities[$i]->text) ?></TD>
	</TR>
<? 	if($i != count($activities)-1){?>
	<TR>
		<TD COLSPAN="9" CLASS="dg_header_cell">&nbsp;</TD>
	</TR>     
<? 	} //If not last ?>
<? } //If detail ?>
<? }?>
</TBODY>
	<TR>
		<TD COLSPAN="4" CLASS="form_header_cell" ALIGN="right">Totals:</TD>
		<TD CLASS="form_field_cell"><?= formatLengthOfTime($total_time) ?></TD>
<? if($loggedin_user->hasRight('admin') || $loggedin_user->hasRight('accounting')){ ?>
		<TD CLASS="form_field_cell">$<?= number_format($total_cost, 2) ?></TD>
		<TD CLASS="form_field_cell">$<?= number_format($total_price, 2) ?></TD>
<? } ?>
		<TD CLASS="form_header_cell" ALIGN="right"></TD>
		<TD CLASS="form_header_cell" ALIGN="right"></TD>
	</TR>
</TABLE>
<? if(isset($commissions) && count($commissions) > 0) { ?>
<BR><BR>
<TABLE BORDER="0" CELLSPACING="0" CELLPADDING="0" CLASS="dg_table">
	<TR>
		<TD COLSPAN="7" CLASS="form_header_cell">
			<TABLE BORDER="0" CELLPADDING="0" CELLSPACING="0" WIDTH="100%">
				<TR>
					<TD>Commissions <?= $title ?></TD>
					<TD ALIGN="right">&nbsp;</TD>
				</TR>
			</TABLE>
		</TD>
	</TR>
	<TR>
		<TD CLASS="dg_header_cell"><A CLASS="link1" HREF="" onClick="return sortTable('bodyId', 0, 1, false)">Project</A></TD>
		<TD CLASS="dg_header_cell"><A CLASS="link1" HREF="" onClick="return sortTable('bodyId', 1, 0, false)">Task</A></TD>
		<TD CLASS="dg_header_cell"><A CLASS="link1" HREF="" onClick="return sortTable('bodyId', 2, 0, false)">Start</A></TD>
		<TD CLASS="dg_header_cell"><A CLASS="link1" HREF="" onClick="return sortTable('bodyId', 3, 0, false)">End</A></TD>
		<TD CLASS="dg_header_cell"><A CLASS="link1" HREF="" onClick="return sortTable('bodyId', 4, 0, false)">Time Spent</A></TD>
<? if($loggedin_user->hasRight('admin') || $loggedin_user->hasRight('accounting')){ ?>
		<TD CLASS="dg_header_cell">Amount?</TD>
<? } ?>
		<TD CLASS="dg_header_cell">Options</TD>
	</TR>
	<TBODY ID="bodyId">
<? 
	$total_com = 0.00;
	for($i = 0; $i < count($commissions); $i++){
		$act_time = ($commissions[$i]->end_ts>0 &&  $commissions[$i]->start_ts>0 ? $commissions[$i]->end_ts - $commissions[$i]->start_ts : 0);
		$total_com += $commissions[$i]->com_amount;
?>
	<TR onMouseOver="this.style.backgroundColor ='#CCCCCC'" onMouseOut="this.style.backgroundColor ='#FFFFFF'">
		<TD CLASS="dg_data_cell_1"><?= $commissions[$i]->project_name ?></TD>
		<TD CLASS="dg_data_cell_1"><?= $commissions[$i]->task_name ?></TD>
		<TD CLASS="dg_data_cell_1"><?= $commissions[$i]->start_ts>0 ? date("n/j/y H:i", $commissions[$i]->start_ts) :  "" ?></TD>
		<TD CLASS="dg_data_cell_1"><?= $commissions[$i]->end_ts>0 ? date("n/j/y H:i", $commissions[$i]->end_ts) :  "" ?></TD>
		<TD CLASS="dg_data_cell_1"><?= $act_time>0 ? formatLengthOfTime($act_time) :  "" ?></TD>
<? if($loggedin_user->hasRight('admin') || $loggedin_user->hasRight('accounting')){ ?>
		<TD CLASS="dg_data_cell_1">$<?= number_format($commissions[$i]->com_amount, 2) ?></TD>
<? } ?>
		<TD CLASS="dg_data_cell_1">&nbsp;
			<A CLASS="link1" HREF="task_activity.php?mode=edit&id=<?= $commissions[$i]->id ?>"><img src="images/edit.gif" width="16" height="16" alt="Edit" border="0" /></A>&nbsp;|&nbsp;
			<A CLASS="link1" HREF="task_activity.php?mode=delete&id=<?= $commissions[$i]->id ?>"><img src="images/delete.gif" width="16" height="16" alt="" border="0" /></A>&nbsp;
		</TD>
	</TR>
<? }?>
</TBODY>
	<TR>
		<TD COLSPAN="5" CLASS="form_header_cell" ALIGN="right">Total:</TD>
<? if($loggedin_user->hasRight('admin') || $loggedin_user->hasRight('accounting')){ ?>
		<TD CLASS="form_field_cell">$<?= number_format($total_com, 2) ?></TD>
<? } ?>
		<TD CLASS="form_header_cell" ALIGN="right"></TD>
	</TR>
</TABLE>
<? } // end if commissions
?>
</FORM>
<? } //end if display_form 
?>

<? require('footer.php') ?>