<?
require_once('includes/common.php');
checkLogin('admin');

require_once('includes/Company.php');
$title = '';
$company = new Company();

// Clean up hourly_rate
if(!empty($_POST['hourly_rate'])){
	$_POST['hourly_rate'] = preg_replace('/[^0-9\.]/','', $_POST['hourly_rate']);
}

if($_REQUEST['mode'] == 'add'){
	$title = "Add Company";
	
	if($_POST['save']){
		$company->updateFromAssocArray($_POST);
		if($company->id = $company->add()){
			goBack();
		}else{
			$error_msg .= "Error adding Company!\n";
			debug_message($company->getLastError());
		}
	}
}else if($_REQUEST['mode'] == 'edit'){
	$title = "Edit Company";
	if(empty($_REQUEST['id'])){
		$error_msg .= "Error: No ID specified!\n";
	}else{
		if(!$company->get($_REQUEST['id'])){
			$error_msg .= "Error retrieving company information!\n";
			debug_message($company->getLastError());
		}
	}

	if($_POST['save']){
		$company->updateFromAssocArray($_POST);
		if($company->update()){
			goBack();
		}else{
			$error_msg .= "Error updating Company!\n";
			debug_message($company->getLastError());
		}
	}
}else if($_REQUEST['mode'] == 'delete'){
	$title = "Delete Company";

	if(!$company->get($_REQUEST['id'])){
		$error_msg .= "Error retrieving company information!\n";
		debug_message($company->getLastError());
	}

	if($_POST['confirm']){
		if($_POST['confirm'] == "Yes"){
			if($company->delete($_REQUEST['id'])){
				goBack();
			}else{
				$error_msg .= "Error deleting Company!\n";
			}
		}else{
			goBack();
		}
	}
}else{
	$title = "Invalid Mode";
	$error_msg .= "Error: Invalid mode!\n";
}

?>
<? require('header.php'); ?>
<FORM ACTION="<?= $_SERVER['PHP_SELF'] ?>" METHOD="POST">
<INPUT NAME="id" TYPE="hidden" VALUE="<?= $_REQUEST['id'] ?>">
<INPUT NAME="mode" TYPE="hidden" VALUE="<?= $_REQUEST['mode'] ?>">
<INPUT NAME="referrer" TYPE="hidden" VALUE="<?= $_REQUEST['referrer'] ?>">
<?if($_REQUEST['mode'] == "delete"){?>
<TABLE BORDER="0" CELLSPACING="0" CELLPADDING="0" CLASS="form_table">
<TR>
	<TD CLASS="form_header_cell"><?= $title ?></TD>
</TR>
<TR>
	<TD CLASS="form_field_cell">
		<BR>Are you sure you want to delete the Company named <b><?= $company->name ?></b>?<BR><BR>
		<SPAN CLASS="error">CAUTION:</SPAN>This action is irreversible.<BR><BR>
	</TD>
</TR>
<TR>
	<TD CLASS="form_footer_cell">
		<DIV ALIGN="center">
			<INPUT TYPE="submit" CLASS="button" NAME="confirm" VALUE="Yes">&nbsp;&nbsp;
			<INPUT TYPE="submit" CLASS="button" NAME="confirm" VALUE="No">
		</DIV>
	</TD>
</TR>
<?}else{?>
<TABLE BORDER="0" CELLSPACING="0" CELLPADDING="0" CLASS="form_table">
<TR>
	<TD COLSPAN="2" CLASS="form_header_cell"><?= $title ?></TD>
</TR>
<TR>
	<TD CLASS="form_field_header_cell">Name:</TD>
	<TD CLASS="form_field_cell"><INPUT NAME="name" CLASS="input_text" SIZE="25" TYPE="text" VALUE="<?= $company->name ?>"></TD>
</TR>
<TR>
	<TD CLASS="form_field_header_cell">Address Line 1:</TD>
	<TD CLASS="form_field_cell"><INPUT NAME="address1" CLASS="input_text" SIZE="35" TYPE="text" VALUE="<?= $company->address1 ?>"></TD>
</TR>
<TR>
	<TD CLASS="form_field_header_cell">Address Line 2:</TD>
	<TD CLASS="form_field_cell"><INPUT NAME="address2" CLASS="input_text" SIZE="35" TYPE="text" VALUE="<?= $company->address2 ?>"></TD>
</TR>
<TR>
	<TD CLASS="form_field_header_cell">City:</TD>
	<TD CLASS="form_field_cell"><INPUT NAME="city" CLASS="input_text" SIZE="35" TYPE="text" VALUE="<?= $company->city ?>"></TD>
</TR>
<TR>
	<TD CLASS="form_field_header_cell">State:</TD>
	<TD CLASS="form_field_cell"><INPUT NAME="state" CLASS="input_text" SIZE="5" TYPE="text" VALUE="<?= $company->state ?>"></TD>
</TR>
<TR>
	<TD CLASS="form_field_header_cell">Zip:</TD>
	<TD CLASS="form_field_cell"><INPUT NAME="zip" CLASS="input_text" SIZE="10" TYPE="text" VALUE="<?= $company->zip ?>"></TD>
</TR>
<TR>
	<TD CLASS="form_field_header_cell">Phone:</TD>
	<TD CLASS="form_field_cell"><INPUT NAME="phone" CLASS="input_text" SIZE="25" TYPE="text" VALUE="<?= $company->phone ?>"></TD>
</TR>
<TR>
	<TD CLASS="form_field_header_cell">Fax:</TD>
	<TD CLASS="form_field_cell"><INPUT NAME="fax" CLASS="input_text" SIZE="25" TYPE="text" VALUE="<?= $company->fax ?>"></TD>
</TR>
<TR>
	<TD CLASS="form_field_header_cell">Hourly Rate:</TD>
	<TD CLASS="form_field_cell"><INPUT NAME="hourly_rate" CLASS="input_text" SIZE="10" TYPE="text" VALUE="<?= $company->hourly_rate ?>"></TD>
</TR>
<TR>
	<TD CLASS="form_field_header_cell">Created On:</TD>
	<TD CLASS="form_field_cell"><?= $company->created_ts ? date("D M jS, Y \a\\t h:i:s A", $company->created_ts) : "" ?></TD>
</TR>
<TR>
	<TD CLASS="form_field_header_cell">Last Updated:</TD>
	<TD CLASS="form_field_cell"><?= $company->updated_ts ? date("D M jS, Y \a\\t h:i:s A", $company->updated_ts) : "" ?></TD>
</TR>
<TR>
	<TD COLSPAN="2" CLASS="form_field_cell">
		<DIV ALIGN="right"><INPUT TYPE="submit" CLASS="button" NAME="save" VALUE="Save"></DIV>
	</TD>
</TR>	
</TABLE>
<?} //if mode==delete?>
</FORM>
<? require('footer.php'); ?>