<?
require_once('InvoiceLineLink.php');

////////////////////////////////////////////////////////////
// Code generated by CodeGen (http://uversaconsulting.net).
// Insert custom code where indicated below.
////////////////////////////////////////////////////////////

// InvoiceLine Class Definition 
////////////////////////////////////////////////////////////
class InvoiceLine{
	var $id, $invoice_id, $quantity, $description, 
	  $unit_price;

	var $error;

	var $_links;

	function InvoiceLine(){
		$this->error = '';
		$this->id = 0;
		$this->invoice_id = 0;
		$this->quantity = 0;
		$this->description = '';
		$this->unit_price = 0;

		$this->_links = array();
	}

	function _populateData($values){
		if(is_array($values)){
			$this->id = $values[0];
			$this->invoice_id = $values[1];
			$this->quantity = $values[2];
			$this->description = $values[3];
			$this->unit_price = $values[4];
		}
	}

	function updateFromAssocArray($array){
		if(is_array($array)){
			foreach($array as $key => $value)
				$this->$key = $value;
		}
	}

	function escapeStrings(){
		global $db_conn;
		
		$vars = get_object_vars($this);
		foreach($vars as $key => $value){
			if(is_string($value)){
				$this->$key = $db_conn->escapeString($value);
			}
		}
	}

	function stripSlashes(){
		$vars = get_object_vars($this);
		foreach($vars as $key => $value){
			if(is_string($value)){
				$this->$key = stripcslashes($value);
			}
		}
	}

	function getLastError(){
		return $this->error;
	}

	function add(){
		global $db_conn;

		$this->escapeStrings();
		$result = $db_conn->query("INSERT INTO invoice_lines (invoice_id, quantity, description, unit_price)".
		  " VALUES(".$this->invoice_id.", ".$this->quantity.", '".$this->description."', ".$this->unit_price.")");
		$this->stripSlashes();
		if($result){
			$this->id = mysql_insert_id($db_conn->_conn);
			if($this->attachLinks($this->_transaction_ids) === FALSE)
        return FALSE;

			return TRUE;
		}else{
			$this->error = "InvoiceLine::add() : ".$db_conn->getLastError()."\n";
			return FALSE;
		}
	}

	function update(){
		global $db_conn;

		if(!isset($this->id)){
			$this->error = "InvoiceLine::update() : InvoiceLine id not set\n";
			return FALSE;
		}

		$this->escapeStrings();
		$result = $db_conn->query("UPDATE invoice_lines SET invoice_id = ".$this->invoice_id.", ".
		  "quantity = ".$this->quantity.", description = '".$this->description."', ".
		  "unit_price = ".$this->unit_price."".
		  " WHERE id = ".$this->id."");
		$this->stripSlashes();
		if($result){
			return TRUE;
		}else{
			$this->error = "InvoiceLine::update() : ".$db_conn->getLastError()."\n";
			return FALSE;
		}
	}

	function delete($id = NULL){
		global $db_conn;

		if(!isset($id)){
			$id = $this->id;
		}

		if(!isset($id)){
			$this->error = "InvoiceLine::delete() : InvoiceLine id not set\n";
			return FALSE;
		}

		$result = $db_conn->query("DELETE FROM invoice_lines WHERE id = $id");

		if($result){
			return TRUE;
		}else{
			$this->error = "InvoiceLine::delete() : ".$db_conn->getLastError()."\n";
			return FALSE;
		}
	}

	function get($id = NULL){
		global $db_conn;

		if(!isset($id)){
			$id = $this->id;
		}

		if(!isset($id)){
			$this->error = "InvoiceLine::get() : InvoiceLine id not set\n";
			return FALSE;
		}

		$InvoiceLine = InvoiceLine::retrieveSet("WHERE id = $id", TRUE);
		if($InvoiceLine === FALSE){
			return FALSE;
		}

		if(isset($InvoiceLine[0])){
			$this->updateFromAssocArray($InvoiceLine[0]);
			if($temp->_populateLinks() === FALSE)
				return FALSE;
			$this->stripSlashes();
		}else{
			$this->error = "InvoiceLine::get() : No data retrieved from query\n";
			return FALSE;
		}
		return TRUE;
	}

	function retrieveSet($clause = '', $raw = FALSE){
		global $db_conn;

		if(!empty($clause)){
			$clause = trim($clause);
			if(strlen($clause) > 5){
				if(strtolower(substr($clause, 0, 5)) != "where" && strtolower(substr($clause, 0, 5)) != "order")
					$clause = "WHERE ".$clause;
			}else{
				$clause = "WHERE ".$clause;
			}
		}

		$result = $db_conn->query("SELECT  id, invoice_id, quantity, description, unit_price".
		  " FROM invoice_lines ".$clause);

		if(!$result){
			$this->error = "InvoiceLine::retrieveSet(): ".$db_conn->getLastError()."\n";
			return FALSE;
		}

		while($row=$result->fetchArray(MYSQL_ASSOC)){
			if($raw == TRUE){
				$InvoiceLine[] = $row;
			}else{
				$temp =& new InvoiceLine();
				$temp->updateFromAssocArray($row);
				if($temp->_populateLinks() === FALSE)
					return FALSE;
				$InvoiceLine[] =& $temp;
			}

		}

		$result->free();
		
		return $InvoiceLine;
	}
// BEGIN - Custom InvoiceLine methods 
////////////////////////////////////////////////////////////
	function getInvoiceLines($invoice_id){
		$clause = "WHERE invoice_id = ".intval($invoice_id);

		$lines = $this->retrieveSet($clause);
		if($lines === FALSE){
			return FALSE;
		}

		return $lines;
	}

	function getTotal(){
		return round($this->quantity * $this->unit_price, 2);
	}

	function attachLinks($append = FALSE){
		global $db_conn;

		if(!$append)
			if($this->clearLinks() === FALSE)
				return FALSE;

		if(count($this->_links) == 0)
			return TRUE;

		foreach($this->_links as $link){
			$link->invoice_line_id = $this->id;
			if($link->add() === FALSE){
				$this->error = "InvoiceLine::attachLinks(): Error adding link: ".$link->getLastError();
				return FALSE;
			}
		}

		return TRUE;
	}

	function clearLinks(){
		global $db_conn;

		$link = new InvoiceLineLink();
		if($link->clearForInvoiceLine($this->id)=== FALSE){
			$this->error = "InvoiceLine::clearLinks(): Error removing links: ".$link->getLastError();
			return FALSE;
		}

		return TRUE;
	}

	function _populateLinks(){
		$ill = new InvoiceLineLink();
		$links = $ill->retrieveSet("WHERE invoice_line_id = ".$this->id); 
		if($links === FALSE){
			$this->error = "InvoiceLine::_populateLinks(): Error getting links: ".$ill->getLastError();
			return FALSE;			
		}
		
		$this->_links =& $links;
		
		return TRUE; 
	}
// END - Custom InvoiceLine methods
////////////////////////////////////////////////////////////
}

