<?
require_once('includes/common.php');
require_once('includes/Invoice.php');
require_once('includes/Company.php');
require_once('includes/TaskActivity.php');
require_once('includes/PaymentSchedule.php');

checkLogin('accounting');

$num_custom_lines = 5;
$activity = new TaskActivity();
$ps = new PaymentSchedule();
$invoice = new Invoice();

if ($_POST['save']){
	$ta_ids = $_POST['task_activity_ids'];
	$ps_ids = $_POST['payment_schedule_ids'];
	$ex_ids = $_POST['expense_ids'];
	
	if(count($ta_ids) == 0 && count($ps_ids) == 0){
		$error_msg .= "You must select at least one item for the invoice!\n";
	}

	if(empty($error_msg)){
		$invoice->updateFromAssocArray($_POST);
		if($invoice->add() !== FALSE){
			if(count($ta_ids) > 0){
				if($invoice->addTaskActivities($ta_ids) === FALSE){
					$error_msg .= "Error adding activities to invoice!\n";
					debug_message($invoice->getLastError());
				}
			}

			if(count($ps_ids) > 0){
				if($invoice->addPaymentSchedules($ps_ids) === FALSE){
					$error_msg .= "Error adding payment schedules to invoice!\n";
					debug_message($invoice->getLastError());
				}
			}

			if(count($ex_ids) > 0){
				if($invoice->addExpenses($ex_ids) === FALSE){
					$error_msg .= "Error adding expenses to invoice!\n";
					debug_message($invoice->getLastError());
				}
			}

			// Add custom line items
			if($invoice->addCustomLines($_REQUEST['custom']) === FALSE){
				$error_msg .= "Error adding custom line items to invoice!\n";
				debug_message($invoice->getLastError());
			}
			
			// Add the company transaction
			$ct = new CompanyTransaction();
			$ct->amount = $invoice->getTotal();
			$ct->company_id = $invoice->company_id;
			$ct->description = "Invoice #".$invoice->id;
			$ct->timestamp = $invoice->timestamp;
			if($ct->add() === FALSE){
				$error_msg .= "Error adding company transaction!\n";
				debug_message($ct->getLastError());
			}

			if(empty($error_msg)){
				goBack();
			}
		}else{
			$error_msg .= "Error adding Invoice!\n";
			debug_message($invoice->getLastError());
		}
	}
}

$_REQUEST['detail'] = strtolower(substr($_REQUEST['detail'],0,1)) == "y" ? TRUE : FALSE;

$company = new Company();
if($company->get($_REQUEST['company_id']) === FALSE){
	$error_msg .= "Could not retrieve information for Company ID ".$_REQUEST['company_id']."!\n";
	debug_message($company->getLastError());
}

$title = "Create Invoice";
$activities = $activity->getActivitiesForCompany($_REQUEST['company_id']);
if($activities === FALSE){
	$error_msg .= "Could not retrieve Activity List for Company ID ".$_REQUEST['company_id']."!\n";
	debug_message($activity->getLastError());
}

$items = $ps->getForCompany($_REQUEST['company_id']);
if($items === FALSE){
	$error_msg .= "Could not retrieve scheduled payments for Company ID ".$_REQUEST['company_id']."!\n";
	debug_message($ps->getLastError());
}

$expenses = $company->getExpenses(TRUE);
if($expenses === FALSE){
	$error_msg .= "Could not retrieve expenses for Company ID ".$_REQUEST['company_id']."!\n";
	debug_message($company->getLastError());
}

$total_time = 0;

require('header.php') ?>
<SCRIPT>
function updatePrice(lineId){
	var oQuantity = document.getElementById('quantity_'+lineId);	
	var oPrice = document.getElementById('price_'+lineId);	
	var oLineTotal = document.getElementById('line_total_'+lineId);	
	var oTotal = document.getElementById('custom_line_total');
	
	var fQuantity = parseFloat(oQuantity.value);
	var fPrice = parseFloat(oPrice.value);
	if(!isNaN(fQuantity) && fQuantity > 0 && !isNaN(fPrice)){
		oLineTotal.innerHTML = Math.round((fQuantity * fPrice)*100)/100;
	}else{
		oLineTotal.innerHTML = '0.00';	
	}
	
	var newTotal = 0.00
	for(i=0; i < <?= $num_custom_lines ?>; i++){
		var oLineTotal = document.getElementById('line_total_'+i);
		var fLineTotal = parseFloat(oLineTotal.innerHTML);
		if(!isNaN(fLineTotal)){
			newTotal = newTotal + fLineTotal;
		}
	}
	oTotal.innerHTML = Math.round(newTotal*100)/100;
}
</SCRIPT>
<FORM ACTION="<?= $_SERVER['PHP_SELF'] ?>" METHOD="POST" NAME="chk">
<INPUT TYPE="hidden" NAME="company_id" VALUE="<?= $_REQUEST['company_id'] ?>">
<INPUT TYPE="hidden" NAME="detail" VALUE="<?= $_REQUEST['detail'] ?>">
<TABLE BORDER="0" CELLSPACING="0" CELLPADDING="0" CLASS="form_table">
<TR>
	<TD COLSPAN="2" CLASS="form_header_cell">Company Information</TD>
</TR>
<TR>
	<TD CLASS="form_field_header_cell">Name:</TD>
	<TD CLASS="form_field_cell"><INPUT NAME="name" CLASS="input_text" SIZE="25" TYPE="text" VALUE="<?= $company->name ?>"></TD>
</TR>
<TR>
	<TD CLASS="form_field_header_cell">Address Line 1:</TD>
	<TD CLASS="form_field_cell"><INPUT NAME="address1" CLASS="input_text" SIZE="35" TYPE="text" VALUE="<?= $company->address1 ?>"></TD>
</TR>
<TR>
	<TD CLASS="form_field_header_cell">Address Line 2:</TD>
	<TD CLASS="form_field_cell"><INPUT NAME="address2" CLASS="input_text" SIZE="35" TYPE="text" VALUE="<?= $company->address2 ?>"></TD>
</TR>
<TR>
	<TD CLASS="form_field_header_cell">City:</TD>
	<TD CLASS="form_field_cell"><INPUT NAME="city" CLASS="input_text" SIZE="35" TYPE="text" VALUE="<?= $company->city ?>"></TD>
</TR>
<TR>
	<TD CLASS="form_field_header_cell">State:</TD>
	<TD CLASS="form_field_cell"><INPUT NAME="state" CLASS="input_text" SIZE="5" TYPE="text" VALUE="<?= $company->state ?>"></TD>
</TR>
<TR>
	<TD CLASS="form_field_header_cell">Zip:</TD>
	<TD CLASS="form_field_cell"><INPUT NAME="zip" CLASS="input_text" SIZE="10" TYPE="text" VALUE="<?= $company->zip ?>"></TD>
</TR>
<TR>
	<TD CLASS="form_field_header_cell">Terms:</TD>
	<TD CLASS="form_field_cell">
		<SELECT NAME="terms" CLASS="input_text">
			<?= Invoice::getTermsSelectTags() ?>
		</SELECT>
	</TD>
</TR>
</TABLE><BR>
<? if(count($activities)>0){ ?>
<TABLE BORDER="0" CELLSPACING="0" CELLPADDING="0" CLASS="dg_table">
	<TR>
		<TD COLSPAN="11" CLASS="form_header_cell">
			<TABLE BORDER="0" CELLPADDING="0" CELLSPACING="0" WIDTH="100%">
				<TR>
					<TD>Select Activities</TD>
					<TD ALIGN="right">
						Detail:&nbsp;
						<A CLASS="<?= $_REQUEST['detail'] == TRUE ? "link3" : "link1" ?>" HREF="<?= $_SERVER['PHP_SELF']."&detail=y" ?>">Yes</A>&nbsp;|&nbsp;
						<A CLASS="<?= $_REQUEST['detail'] == TRUE ? "link1" : "link3" ?>" HREF="<?= $_SERVER['PHP_SELF']."&detail=n" ?>">No</A>
					</TD>
				</TR>
			</TABLE>
		</TD>
	</TR>
	<TR>
		<TD CLASS="dg_header_cell"><A CLASS="link1" HREF="" onClick="return sortTable('bodyId', 0, 1, false)">Project</A></TD>
		<TD CLASS="dg_header_cell"><A CLASS="link1" HREF="" onClick="return sortTable('bodyId', 1, 0, false)">Task</A></TD>
		<TD CLASS="dg_header_cell"><A CLASS="link1" HREF="" onClick="return sortTable('bodyId', 2, 0, false)">Start</A></TD>
		<TD CLASS="dg_header_cell"><A CLASS="link1" HREF="" onClick="return sortTable('bodyId', 3, 0, false)">End</A></TD>
		<TD CLASS="dg_header_cell"><A CLASS="link1" HREF="" onClick="return sortTable('bodyId', 4, 0, false)">Time Spent</A></TD>
		<TD CLASS="dg_header_cell"><A CLASS="link1" HREF="" onClick="return sortTable('bodyId', 5, 0, false)">Hourly Rate</A></TD>
		<TD CLASS="dg_header_cell"><A CLASS="link1" HREF="" onClick="return sortTable('bodyId', 6, 0, false)">Price</A></TD>
		<TD CLASS="dg_header_cell">Include?</TD>
		<TD CLASS="dg_header_cell">Options</TD>
	</TR>
	<TBODY ID="bodyId">
<? for($i = 0; $i < count($activities); $i++){
		if($activities[$i]->hourly_rate <= 0)
			continue;

		$activities[$i]->_calcPrice();
		$act_time = ($activities[$i]->end_ts>0 &&  $activities[$i]->start_ts>0 ? $activities[$i]->end_ts - $activities[$i]->start_ts : 0);
		$total_time += $act_time;
		$total_cost += $activities[$i]->cost;
		$total_com += $activities[$i]->com_amount;
		$total_price += $activities[$i]->price;
?>
	<TR onMouseOver="this.style.backgroundColor ='#CCCCCC'" onMouseOut="this.style.backgroundColor ='#FFFFFF'">
		<TD CLASS="dg_data_cell_1"><?= $activities[$i]->project_name ?></TD>
		<TD CLASS="dg_data_cell_1"><?= $activities[$i]->task_name ?></TD>
		<TD CLASS="dg_data_cell_1"><?= $activities[$i]->start_ts>0 ? date("n/j/y H:i", $activities[$i]->start_ts) :  "" ?></TD>
		<TD CLASS="dg_data_cell_1"><?= $activities[$i]->end_ts>0 ? date("n/j/y H:i", $activities[$i]->end_ts) :  "" ?></TD>
		<TD CLASS="dg_data_cell_1"><?= $act_time>0 ? formatLengthOfTime($act_time) :  "" ?></TD>
		<TD CLASS="dg_data_cell_1">$<?= number_format($activities[$i]->hourly_rate, 2) ?></TD>
		<TD CLASS="dg_data_cell_1">$<?= number_format($activities[$i]->price, 2) ?></TD>
		<TD CLASS="dg_data_cell_1"><INPUT TYPE="checkbox" NAME="task_activity_ids[]" VALUE="<?= $activities[$i]->id ?>"></TD>
		<TD CLASS="dg_data_cell_1">&nbsp;
			<A CLASS="link1" HREF="task_activity.php?mode=edit&id=<?= $activities[$i]->id ?>"><img src="images/edit.gif" width="16" height="16" alt="Edit" border="0" /></A>&nbsp;|&nbsp;
			<A CLASS="link1" HREF="task_activity.php?mode=delete&id=<?= $activities[$i]->id ?>"><img src="images/delete.gif" width="16" height="16" alt="" border="0" /></A>&nbsp;
		</TD>
	</TR>
<? if($_REQUEST['detail']){?>
	<TR>
		<TD COLSPAN="11" CLASS="dg_data_cell_1"><?= nl2br($activities[$i]->text) ?></TD>
	</TR>
<? 		if($i != count($activities)-1){?>
	<TR>
		<TD COLSPAN="11" CLASS="dg_header_cell">&nbsp;</TD>
	</TR>
<? 		} //If not last
	} //If detail 
}?>
</TBODY>
	<TR>
		<TD COLSPAN="4" CLASS="form_header_cell" ALIGN="right">Totals:</TD>
		<TD CLASS="form_field_cell"><?= formatLengthOfTime($total_time) ?></TD>
		<TD CLASS="form_header_cell"></TD>
		<TD CLASS="form_field_cell">$<?= number_format($total_price, 2) ?></TD>
		<TD CLASS="form_header_cell"><INPUT TYPE="checkbox" NAME="select_all" onClick='SelectAll("task_activity_ids[]")'></TD>
		<TD CLASS="form_header_cell" ALIGN="right"></TD>
	</TR>
	<TR>
		<TD COLSPAN="8" CLASS="form_header_cell" ALIGN="right">&nbsp;</TD>
		<TD COLSPAN="2" CLASS="form_header_cell" ALIGN="right">
			<INPUT TYPE="submit" NAME="save" VALUE="Create Invoice"/>
		</TD>
	</TR>
</TABLE>
<BR><BR>
<? } ?>
<? if(count($items)>0){ ?>
<TABLE BORDER="0" CELLSPACING="0" CELLPADDING="0" CLASS="dg_table">
	<TR>
		<TD COLSPAN="7" CLASS="form_header_cell">
			<TABLE BORDER="0" CELLPADDING="0" CELLSPACING="0" WIDTH="100%">
				<TR>
					<TD>Select Scheduled Payments</TD>
					<TD ALIGN="right">&nbsp;
					</TD>
				</TR>
			</TABLE>
		</TD>
	</TR>
	<TR>
		<TD CLASS="dg_header_cell"><A CLASS="link1" HREF="" onClick="return sortTable('bodyId', 0, 1, false)">Project</A></TD>
		<TD CLASS="dg_header_cell"><A CLASS="link1" HREF="" onClick="return sortTable('bodyId', 1, 0, false)">Task</A></TD>
		<TD CLASS="dg_header_cell"><A CLASS="link1" HREF="" onClick="return sortTable('bodyId', 2, 0, false)">Due Date</A></TD>
		<TD CLASS="dg_header_cell"><A CLASS="link1" HREF="" onClick="return sortTable('bodyId', 3, 0, false)">Description</A></TD>
		<TD CLASS="dg_header_cell"><A CLASS="link1" HREF="" onClick="return sortTable('bodyId', 4, 0, false)">Amount</A></TD>
		<TD CLASS="dg_header_cell">Include?</TD>
		<TD CLASS="dg_header_cell">Options</TD>
	</TR>
	<TBODY ID="bodyId">
<? for($i = 0; $i < count($items); $i++){
		$total_price2 += $items[$i]->amount;
?>
	<TR onMouseOver="this.style.backgroundColor ='#CCCCCC'" onMouseOut="this.style.backgroundColor ='#FFFFFF'">
		<TD CLASS="dg_data_cell_1"><?= $items[$i]->getProjectName() ?></TD>
		<TD CLASS="dg_data_cell_1"><?= $items[$i]->getTaskName() ?></TD>
		<TD CLASS="dg_data_cell_1"><?= $items[$i]->due_ts>0 ? date("n/j/y", $items[$i]->due_ts) :  "" ?></TD>
		<TD CLASS="dg_data_cell_1"><?= $items[$i]->description ?></TD>
		<TD CLASS="dg_data_cell_1">$<?= number_format($items[$i]->amount, 2) ?></TD>
		<TD CLASS="dg_data_cell_1"><INPUT TYPE="checkbox" NAME="payment_schedule_ids[]" VALUE="<?= $items[$i]->id ?>"></TD>
		<TD CLASS="dg_data_cell_1">&nbsp;
			<A CLASS="link1" HREF="payment_schedule.php?mode=edit&id=<?= $items[$i]->id ?>"><img src="images/edit.gif" width="16" height="16" title="Edit" border="0" /></A>&nbsp;|&nbsp;
			<A CLASS="link1" HREF="payment_schedule.php?mode=delete&id=<?= $items[$i]->id ?>"><img src="images/delete.gif" width="16" height="16" title="Delete" border="0" /></A>&nbsp;
		</TD>
	</TR>
<? }?>
</TBODY>
	<TR>
		<TD COLSPAN="4" CLASS="form_header_cell" ALIGN="right">Total:</TD>
		<TD CLASS="form_field_cell">$<?= number_format($total_price2, 2) ?></TD>
		<TD CLASS="form_header_cell"><INPUT TYPE="checkbox" NAME="select_all" onClick='SelectAll("payment_schedule_ids[]")'></TD>
		<TD CLASS="form_header_cell" ALIGN="right"></TD>
	</TR>
	<TR>
		<TD COLSPAN="7" CLASS="form_header_cell" ALIGN="right">
			<INPUT TYPE="submit" NAME="save" VALUE="Create Invoice"/>
		</TD>
	</TR>
</TABLE>
<BR><BR>
<? } ?>
<? if(count($expenses)>0){ ?>
<TABLE BORDER="0" CELLSPACING="0" CELLPADDING="0" CLASS="dg_table">
	<TR>
		<TD COLSPAN="7" CLASS="form_header_cell">
			<TABLE BORDER="0" CELLPADDING="0" CELLSPACING="0" WIDTH="100%">
				<TR>
					<TD>Select Expenses</TD>
					<TD ALIGN="right">&nbsp;
					</TD>
				</TR>
			</TABLE>
		</TD>
	</TR>
	<TR>
		<TD CLASS="dg_header_cell"><A CLASS="link1" HREF="" onClick="return sortTable('bodyId', 0, 1, false)">Project</A></TD>
		<TD CLASS="dg_header_cell"><A CLASS="link1" HREF="" onClick="return sortTable('bodyId', 1, 0, false)">Date</A></TD>
		<TD CLASS="dg_header_cell"><A CLASS="link1" HREF="" onClick="return sortTable('bodyId', 3, 0, false)">Description</A></TD>
		<TD CLASS="dg_header_cell"><A CLASS="link1" HREF="" onClick="return sortTable('bodyId', 4, 0, false)">Amount</A></TD>
		<TD CLASS="dg_header_cell">Include?</TD>
		<TD CLASS="dg_header_cell">Options</TD>
	</TR>
	<TBODY ID="bodyId">
<? for($i = 0; $i < count($expenses); $i++){
		$total_price3 += $expenses[$i]->price;
?>
	<TR onMouseOver="this.style.backgroundColor ='#CCCCCC'" onMouseOut="this.style.backgroundColor ='#FFFFFF'">
		<TD CLASS="dg_data_cell_1"><?= $expenses[$i]->getProjectName() ?></TD>
		<TD CLASS="dg_data_cell_1"><?= $expenses[$i]->created_ts>0 ? date("n/j/y", $expenses[$i]->created_ts) :  "" ?></TD>
		<TD CLASS="dg_data_cell_1"><?= $expenses[$i]->description ?></TD>
		<TD CLASS="dg_data_cell_1">$<?= number_format($expenses[$i]->price, 2) ?></TD>
		<TD CLASS="dg_data_cell_1"><INPUT TYPE="checkbox" NAME="expense_ids[]" VALUE="<?= $expenses[$i]->id ?>"></TD>
		<TD CLASS="dg_data_cell_1">&nbsp;
			<A CLASS="link1" HREF="expense.php?mode=edit&id=<?= $expenses[$i]->id ?>"><img src="images/edit.gif" width="16" height="16" title="Edit" border="0" /></A>&nbsp;|&nbsp;
			<A CLASS="link1" HREF="expense.php?mode=delete&id=<?= $expenses[$i]->id ?>"><img src="images/delete.gif" width="16" height="16" title="Delete" border="0" /></A>&nbsp;
		</TD>
	</TR>
<? }?>
</TBODY>
	<TR>
		<TD COLSPAN="3" CLASS="form_header_cell" ALIGN="right">Total:</TD>
		<TD CLASS="form_field_cell">$<?= number_format($total_price3, 2) ?></TD>
		<TD CLASS="form_header_cell"><INPUT TYPE="checkbox" NAME="select_all" onClick='SelectAll("expense_ids[]")'></TD>
		<TD CLASS="form_header_cell" ALIGN="right"></TD>
	</TR>
	<TR>
		<TD COLSPAN="7" CLASS="form_header_cell" ALIGN="right">
			<INPUT TYPE="submit" NAME="save" VALUE="Create Invoice"/>
		</TD>
	</TR>
</TABLE>
<BR><BR>
<? } ?>
<TABLE BORDER="0" CELLSPACING="0" CELLPADDING="0" CLASS="dg_table">
	<TR>
		<TD COLSPAN="7" CLASS="form_header_cell">
			<TABLE BORDER="0" CELLPADDING="0" CELLSPACING="0" WIDTH="100%">
				<TR>
					<TD>Add Custom Line Items</TD>
					<TD ALIGN="right">&nbsp;
					</TD>
				</TR>
			</TABLE>
		</TD>
	</TR>
	<TR>
		<TD CLASS="dg_header_cell">Quantity</TD>
		<TD CLASS="dg_header_cell">Description</TD>
		<TD CLASS="dg_header_cell">Unit Price</TD>
		<TD CLASS="dg_header_cell">Extended Price</TD>
	</TR>
	<TBODY ID="bodyId">
<? for($i = 0; $i < $num_custom_lines; $i++){?>
	<TR onMouseOver="this.style.backgroundColor ='#CCCCCC'" onMouseOut="this.style.backgroundColor ='#FFFFFF'">
		<TD CLASS="dg_data_cell_1"><input type="text" class="input_text" name="custom[<?= $i ?>][quantity]" id="quantity_<?= $i ?>" size="10" maxlength="20" onchange="updatePrice(<?= $i ?>)"/></TD>
		<TD CLASS="dg_data_cell_1"><input type="text" class="input_text" name="custom[<?= $i ?>][description]" id="description_<?= $i ?>" size="40" maxlength="255"/></TD>
		<TD CLASS="dg_data_cell_1"><input type="text" class="input_text" name="custom[<?= $i ?>][price]" id="price_<?= $i ?>" size="10" maxlength="20" onchange="updatePrice(<?= $i ?>)"/></TD>
		<TD CLASS="dg_data_cell_1">$<SPAN id="line_total_<?= $i ?>">0.00</SPAN></TD>
	</TR>
<? }?>
	</TBODY>
	<TR>
		<TD COLSPAN="3" CLASS="form_header_cell" ALIGN="right">Custom Line Item Total:</TD>
		<TD CLASS="form_field_cell">$<SPAN id="custom_line_total">0.00</SPAN></TD>
	</TR>
	<TR>
		<TD COLSPAN="7" CLASS="form_header_cell" ALIGN="right">
			<INPUT TYPE="submit" NAME="save" VALUE="Create Invoice"/>
		</TD>
	</TR>
</TABLE>

</FORM>
<? require('footer.php') ?>
