<?
require_once('includes/common.php');
require_once('includes/Invoice.php');
require_once('includes/Company.php');
require_once('includes/TaskActivity.php');
require_once('includes/Payment.php');

checkLogin();

if(intval($_REQUEST['id']) == 0){
  fatal_error("You must provide an invoice id to view!");
}

$invoice = new Invoice();
if($invoice->get(intval($_REQUEST['id'])) === FALSE){
  $error_msg .= "Error retreiving invoice information!\n";
  debug_message($invoice->getLastError());
}

$company = new Company();
if($company->get($invoice->company_id) === FALSE){
  $error_msg .= "Error retreiving company information!\n";
  debug_message($company->getLastError());
}

if(!$loggedin_user->hasRight('admin') && !$loggedin_user->hasRight('admin')){
	if($loggedin_user->company_id != $invoice->company_id){
		fatal_error("You do not have rights to access this invoice!");	
	}
	
}

$payment = new Payment();
$payments = $payment->getForInvoice($invoice->id);
if($payments === FALSE){
	$error_msg .= "Error retreiving payment information!\n";
	debug_message($payment->getLastError());
}

$_REQUEST['detail'] = strtolower(substr($_REQUEST['detail'],0,1)) == "y" ? TRUE : FALSE;
$url = $_SERVER['PHP_SELF'].'?id='.$_REQUEST['id'].'&';

$title = "View Invoice";

require('header.php') ?>
<TABLE BORDER="0" CELLSPACING="0" CELLPADDING="0" CLASS="form_table">
<TR>
	<TD COLSPAN="2" CLASS="form_header_cell">Company Information</TD>
</TR>
<TR>
	<TD CLASS="form_field_header_cell">Name:</TD>
	<TD CLASS="form_field_cell"><?= $company->name?></TD>
</TR>
<TR>
	<TD CLASS="form_field_header_cell">Address Line 1:</TD>
	<TD CLASS="form_field_cell"><?= $invoice->address1 ?></TD>
</TR>
<TR>
	<TD CLASS="form_field_header_cell">Address Line 2:</TD>
	<TD CLASS="form_field_cell"><?= $invoice->address2 ?></TD>
</TR>
<TR>
	<TD CLASS="form_field_header_cell">City:</TD>
	<TD CLASS="form_field_cell"><?= $invoice->city ?></TD>
</TR>
<TR>
	<TD CLASS="form_field_header_cell">State:</TD>
	<TD CLASS="form_field_cell"><?= $invoice->state ?></TD>
</TR>
<TR>
	<TD CLASS="form_field_header_cell">Zip:</TD>
	<TD CLASS="form_field_cell"><?= $invoice->zip ?></TD>
</TR>
<TR>
	<TD CLASS="form_field_header_cell">Terms:</TD>
	<TD CLASS="form_field_cell"><?= $invoice->terms ?></TD>
</TR>
<TR>
	<TD CLASS="form_field_header_cell">Amount Due:</TD>
	<TD CLASS="form_field_cell"><b>$<?= number_format($invoice->getAmountDue(), 2) ?></b></TD>
</TR>
</TABLE><BR>
<TABLE BORDER="0" CELLSPACING="0" CELLPADDING="0" CLASS="dg_table">
	<TR>
		<TD COLSPAN="11" CLASS="form_header_cell">
			<TABLE BORDER="0" CELLPADDING="0" CELLSPACING="0" WIDTH="100%">
				<TR>
					<TD>Line Items</TD>
					<TD ALIGN="right">
						Detail:&nbsp;
						<A CLASS="<?= $_REQUEST['detail'] == TRUE ? "link3" : "link1" ?>" HREF="<?= $url."detail=y" ?>">Yes</A>&nbsp;|&nbsp;
						<A CLASS="<?= $_REQUEST['detail'] == TRUE ? "link1" : "link3" ?>" HREF="<?= $url."detail=n" ?>">No</A>
					</TD>
				</TR>
			</TABLE>
		</TD>
	</TR>
	<TR>
		<TD CLASS="dg_header_cell"><A CLASS="link1" HREF="" onClick="return sortTable('bodyId', 0, 1, false)">Quantity</A></TD>
		<TD CLASS="dg_header_cell"><A CLASS="link1" HREF="" onClick="return sortTable('bodyId', 1, 0, false)">Description</A></TD>
		<TD CLASS="dg_header_cell"><A CLASS="link1" HREF="" onClick="return sortTable('bodyId', 2, 0, false)">Unit Price</A></TD>
		<TD CLASS="dg_header_cell"><A CLASS="link1" HREF="" onClick="return sortTable('bodyId', 3, 0, false)">Total</A></TD>
	</TR>
	<TBODY ID="bodyId">
<? for($i = 0; $i < count($invoice->_lines); $i++){ ?>
	<TR onMouseOver="this.style.backgroundColor ='#CCCCCC'" onMouseOut="this.style.backgroundColor ='#FFFFFF'">
		<TD CLASS="dg_data_cell_1"><?= $invoice->_lines[$i]->quantity ?></TD>
		<TD CLASS="dg_data_cell_1"><?= $invoice->_lines[$i]->description ?></TD>
		<TD CLASS="dg_data_cell_1"><?= $invoice->_lines[$i]->unit_price ?></TD>
		<TD CLASS="dg_data_cell_1"><?= number_format($invoice->_lines[$i]->getTotal(), 2);  ?></TD>
	</TR>
<? if($_REQUEST['detail']){
	$links =& $invoice->_lines[$i]->_links; 
	for($x=0; $x<count($links); $x++){ 
		if($links[$x]->task_activity_id > 0){ 
			$ta = new TaskActivity();
			$ta->get($links[$x]->task_activity_id); ?>
	<TR>
		<TD COLSPAN="11" CLASS="dg_data_cell_1">
			<table cellpadding="2" cellspacing="0">
    		<tr>
      			<td valign="top" nowrap><B><?= date("n/j/y H:i", $ta->start_ts)."-".date("H:i", $ta->end_ts)?></B></td>
      			<td valign="top"><?= $ta->text ?></td>
			</tr>
			</table>
		</TD>
	</TR>
<?		}
		if($links[$x]->payment_schedule_id > 0){
			$ps = new PaymentSchedule();
			$ps->get($links[$x]->payment_schedule_id); ?>
	<TR>
		<TD COLSPAN="11" CLASS="dg_data_cell_1"><?= $ps->description ?></TD>
	</TR>
<?		} ?>
<? 	} // end for links
	if($i != count($activities)-1){?>
	<TR>
		<TD COLSPAN="11" CLASS="dg_header_cell">&nbsp;</TD>
	</TR>
<? 	} //If not last ?>
<? } //If detail ?>
<? }?>
</TBODY>
	<TR>
		<TD COLSPAN="3" CLASS="form_header_cell" ALIGN="right">Totals:</TD>
		<TD CLASS="form_field_cell">$<?= number_format($invoice->getTotal(), 2) ?></TD>
	</TR>
</TABLE>
<BR>
<? if(count($payments) > 0){ ?>
<TABLE BORDER="0" CELLSPACING="0" CELLPADDING="0" CLASS="dg_table">
	<TR>
		<TD COLSPAN="3" CLASS="form_header_cell">Payments</TD>
	</TR>
	<TR>
		<TD CLASS="dg_header_cell"><A CLASS="link1" HREF="" onClick="return sortTable('bodyId', 0, 1, false)">Date</A></TD>
		<TD CLASS="dg_header_cell"><A CLASS="link1" HREF="" onClick="return sortTable('bodyId', 1, 0, false)">Type</A></TD>
		<TD CLASS="dg_header_cell"><A CLASS="link1" HREF="" onClick="return sortTable('bodyId', 2, 0, false)">Amount</A></TD>
	</TR>
	<TBODY ID="bodyId">
<? for($i = 0; $i < count($payments); $i++){ ?>
	<TR onMouseOver="this.style.backgroundColor ='#CCCCCC'" onMouseOut="this.style.backgroundColor ='#FFFFFF'">
		<TD CLASS="dg_data_cell_1"><?= date("n/j/y H:i", $payments[$i]->timestamp) ?></TD>
		<TD CLASS="dg_data_cell_1"><?= $payments[$i]->type ?></TD>
		<TD CLASS="dg_data_cell_1"><?= number_format($payments[$i]->getAmountForInvoice($invoice->id), 2);  ?></TD>
	</TR>
<? }?>
</TBODY>
	<TR>
		<TD COLSPAN="2" CLASS="form_header_cell" ALIGN="right">Total Paid:</TD>
		<TD CLASS="form_field_cell">$<?= number_format(($invoice->getTotal() - $invoice->getAmountDue()), 2) ?></TD>
	</TR>
</TABLE>
<? } ?>
</FORM>
<? require('footer.php') ?>