<?
require_once('includes/common.php');
require_once('includes/Project.php');
require_once('includes/Company.php');
require_once('includes/Task.php');

checkLogin();

$project = new Project();

if($loggedin_user->hasRight('admin') && isset($_REQUEST['user_id'])){
	$user_id = $_REQUEST['user_id'];
}else{
	$user_id = $loggedin_user->id;
}

if($_REQUEST['filter'] == "all"){
	$projects = $project->getMyProjects($user_id, FALSE);
}else{
	$_REQUEST['filter'] = "pending";
	$projects = $project->getMyProjects($user_id, TRUE);
}

if($projects === FALSE){
	$error_msg .= "Could not retrieve your project list!\n";
	debug_message($project->getLastError());
}

$task = new Task();
$tasks = $task->getUpcoming($user_id);
if($tasks === FALSE){
	$error_msg .= "Could not retrieve Upcoming Tasks!\n";
	debug_message($task->getLastError());
}

$company = new Company();
$companies = $company->getCompanysWithBalance();
if($companies === FALSE){
	$error_msg .= "Could not retrieve Outstanding Hours list!\n";
	debug_message($company->getLastError());
}

$user = new User();
$users = $user->getUnpaidUsers();
if($users === FALSE){
	$error_msg .= "Could not retrieve Unpaid Users's list!\n";
	debug_message($user->getLastError());
}

$title = "My Projects";

require('header.php'); ?>
<SCRIPT>
function reloadPage(selObj){
	var user_id = selObj.options[selObj.selectedIndex].value;
	window.location.href = "<?= $_SERVER['PHP_SELF'] ?>?filter=<?= $_REQUEST['filter'] ?>&user_id="+user_id;
}
</SCRIPT>
<TABLE BORDER="0" CELLSPACING="0" CELLPADDING="0" CLASS="dg_table">
	<TR>
		<TD COLSPAN="6" CLASS="form_header_cell">
			<TABLE BORDER="0" CELLPADDING="0" CELLSPACING="0" WIDTH="100%">
				<TR>
					<TD>
						My Projects&nbsp;
<?	if($loggedin_user->hasRight('admin')){?>
						<SELECT NAME="user_id" onChange="javascript:reloadPage(this)" CLASS="input_text">
							<?= User::getSelectTags($user_id) ?>
						</SELECT>
<?	} //if admin 
?>
						<A CLASS="link1" HREF="project.php?mode=add">
						<img src="images/new.gif" width="16" height="16" title="New Project" border="0" /></A>
					</TD>
					<TD ALIGN="right">
						Filter:&nbsp;
						<A CLASS="<?= $_REQUEST['filter'] == "all" ? "link3" : "link1" ?>" HREF="my_projects.php?filter=all<?= $loggedin_user->hasRight('admin') ? '&user_id='.$user_id : '' ?>">All</A>&nbsp;|&nbsp;
						<A CLASS="<?= $_REQUEST['filter'] == "all" ? "link1" : "link3" ?>" HREF="my_projects.php?filter=pending<?= $loggedin_user->hasRight('admin') ? '&user_id='.$user_id : '' ?>">Pending</A>
					</TD>
				</TR>
			</TABLE>
		</TD>
	</TR>
	<TR>
		<TD CLASS="dg_header_cell"><A CLASS="link1" HREF="" onClick="return sortTable('bodyId', 0, 1, false)">Name</A></TD>
		<TD CLASS="dg_header_cell"><A CLASS="link1" HREF="" onClick="return sortTable('bodyId', 1, 0, false)">Company</A></TD>
		<TD CLASS="dg_header_cell"><A CLASS="link1" HREF="" onClick="return sortTable('bodyId', 2, 0, false)">Status</A></TD>
		<TD CLASS="dg_header_cell"><A CLASS="link1" HREF="" onClick="return sortTable('bodyId', 3, 0, false)">Due Date</A></TD>
		<TD CLASS="dg_header_cell"><A CLASS="link1" HREF="" onClick="return sortTable('bodyId', 4, 0, false)">Priority</A></TD>
		<TD CLASS="dg_header_cell">Options</TD>
	</TR>
	<TBODY ID="bodyId">
<? for($i = 0; $i < count($projects); $i++){ ?>
	<TR onMouseOver="this.style.backgroundColor ='#CCCCCC'" onMouseOut="this.style.backgroundColor ='#FFFFFF'">
		<TD CLASS="dg_data_cell_1"><A title="Project Details" HREF="project_details.php?id=<?= $projects[$i]->id ?>"><?= $projects[$i]->name ?></A></TD>
		<TD CLASS="dg_data_cell_1"><A title="Company Detail Center" HREF="company_detail.php?id=<?= $projects[$i]->company_id ?>"><?= $projects[$i]->company_name ?></A></TD>
		<TD CLASS="dg_data_cell_1"><?= $projects[$i]->status ?></TD>
		<TD CLASS="dg_data_cell_1"><?=  $projects[$i]->due_ts>0 ? date("n/j/y", $projects[$i]->due_ts) : "None" ?></TD>
		<TD CLASS="dg_data_cell_1"><?= $projects[$i]->priority ?></TD>
		<TD CLASS="dg_data_cell_1">&nbsp;
			<A CLASS="link1" HREF="project_details.php?id=<?= $projects[$i]->id ?>&referrer=<?= urlencode($_SERVER['PHP_SELF']."?".$_SERVER['QUERY_STRING']) ?>"><img src="images/properties.gif" width="16" height="16" title="Project Details" border="0" /></A>
<?	if($projects[$i]->hasRights(PROJECT_RIGHT_EDIT)){?>
			&nbsp;|&nbsp;<A CLASS="link1" HREF="project.php?mode=edit&id=<?= $projects[$i]->id ?>&referrer=<?= urlencode($_SERVER['PHP_SELF']."?".$_SERVER['QUERY_STRING']) ?>"><img src="images/edit.gif" width="16" height="16" title="Edit Project" border="0" /></A>
<?	}?>
<?	if($projects[$i]->hasRights(PROJECT_RIGHT_FULL)){?>
			&nbsp;|&nbsp;<A CLASS="link1" HREF="project.php?mode=delete&id=<?= $projects[$i]->id ?>&referrer=<?= urlencode($_SERVER['PHP_SELF']."?".$_SERVER['QUERY_STRING']) ?>"><img src="images/delete.gif" width="16" height="16" title="Delete Project" border="0" /></A>&nbsp;
<?	}?>
		</TD>
	</TR>
<? }?>
</TBODY>
</TABLE>
<BR><BR>
<? if($loggedin_user->isDeveloper()){ ?>
<TABLE BORDER="0" CELLSPACING="0" CELLPADDING="0" CLASS="dg_table">
	<TR>
		<TD COLSPAN="6" CLASS="form_header_cell">Upcoming Tasks</TD>
	</TR>
	<TR>
		<TD CLASS="dg_header_cell"><A CLASS="link1" HREF="" onClick="return sortTable('bodyId1', 0, 1, false)">Project</A></TD>
		<TD CLASS="dg_header_cell"><A CLASS="link1" HREF="" onClick="return sortTable('bodyId1', 1, 0, false)">Task</A></TD>
		<TD CLASS="dg_header_cell"><A CLASS="link1" HREF="" onClick="return sortTable('bodyId1', 2, 0, false)">Status</A></TD>
		<TD CLASS="dg_header_cell"><A CLASS="link1" HREF="" onClick="return sortTable('bodyId1', 3, 0, false)">Due Date</A></TD>
		<TD CLASS="dg_header_cell"><A CLASS="link1" HREF="" onClick="return sortTable('bodyId1', 4, 0, false)">Priority</A></TD>
		<TD CLASS="dg_header_cell">Options</TD>
	</TR>
	<TBODY ID="bodyId1">
<? for($i = 0; $i < count($tasks); $i++){ ?>
	<TR onMouseOver="this.style.backgroundColor ='#CCCCCC'" onMouseOut="this.style.backgroundColor ='#FFFFFF'">
		<TD CLASS="dg_data_cell_1"><A title="Project Details" HREF="project_details.php?id=<?= $tasks[$i]->project_id ?>"><?= $tasks[$i]->project ?></A></TD>
		<TD CLASS="dg_data_cell_1"><A title="Task Activities" HREF="task_activity.php?mode=add&task_id=<?= $tasks[$i]->id ?>"><?= $tasks[$i]->name ?></A></TD>
		<TD CLASS="dg_data_cell_1"><?= $tasks[$i]->status ?></TD>
		<TD CLASS="dg_data_cell_1"><?= $tasks[$i]->due_ts>0 ? date("n/j/y", $tasks[$i]->due_ts) : "None" ?></TD>
		<TD CLASS="dg_data_cell_1"><?= $tasks[$i]->priority ?></TD>
		<TD CLASS="dg_data_cell_1">&nbsp;
			<A CLASS="link1" HREF="task_activity.php?mode=add&task_id=<?= $tasks[$i]->id ?>&referrer=<?= urlencode($_SERVER['PHP_SELF']."?".$_SERVER['QUERY_STRING']) ?>"><img src="images/activity_add.gif" width="16" height="16" title="Add Activity" border="0" /></A>&nbsp;|&nbsp;
			<A CLASS="link1" HREF="task_activities.php?task_id=<?= $tasks[$i]->id ?>&referrer=<?= urlencode($_SERVER['PHP_SELF']."?".$_SERVER['QUERY_STRING']) ?>"><img src="images/activity.gif" width="16" height="16" title="Task Activities" border="0" /></A>&nbsp;|&nbsp;
			<A CLASS="link1" HREF="project_task.php?mode=edit&id=<?= $tasks[$i]->id ?>&referrer=<?= urlencode($_SERVER['PHP_SELF']."?".$_SERVER['QUERY_STRING']) ?>"><img src="images/edit.gif" width="16" height="16" title="Edit Task" border="0" /></A>&nbsp;|&nbsp;
			<A CLASS="link1" HREF="project_task.php?mode=delete&id=<?= $tasks[$i]->id ?>&referrer=<?= urlencode($_SERVER['PHP_SELF']."?".$_SERVER['QUERY_STRING']) ?>"><img src="images/delete.gif" width="16" height="16" title="Delete Task" border="0" /></A>&nbsp;
		</TD>
	</TR>
<? }?>
</TBODY>
</TABLE>
<? } // end if developer ?>
<BR><BR>
<? require('footer.php') ?>
