<?
require_once('includes/common.php');
require_once('includes/PaymentSchedule.php');
require_once('includes/CompanyTransaction.php');
require_once('includes/Project.php');
require_once('includes/Task.php');
checkLogin('accounting');

$title = '';
$ps = new PaymentSchedule();
$project = new Project();
$task = new Task();

if($_REQUEST['mode'] == 'add'){
	$title = "Add Payment Schedule";

	$project_id = intval($_REQUEST['project_id']);
	$task_id = intval($_REQUEST['task_id']);
	if($project_id == 0 && $task_id == 0){
		fatal_error("You must provide a task_id or project_id for this scheduled payment!\n");
	}

	if($task_id > 0){
		if($task->get($task_id) === FALSE){
			$error_msg .= "Error getting task information!\n";
			debug_message($task->getLastError());
		}

		if($project->get($task->project_id) === FALSE){
			$error_msg .= "Error getting project information!\n";
			debug_message($project->getLastError());
		}
	}else{
		if($project->get($project_id) === FALSE){
			$error_msg .= "Error getting project information!\n";
			debug_message($project->getLastError());
		}
	}


	if($_POST['save']){
		$_POST['due_ts'] = getDateSelectorTS("due_ts");
		$ps->updateFromAssocArray($_POST);
		if($ps->add()){
			goBack();
		}else{
			$error_msg .= "Error adding Payment Schedule!\n";
			debug_message($ps->getLastError());
		}
	}
}else if($_REQUEST['mode'] == 'edit'){
	$title = "Edit Payment Schedule";
	if(empty($_REQUEST['id'])){
		$error_msg .= "Error: No ID specified!\n";
	}else{
		if(!$ps->get($_REQUEST['id'])){
			$error_msg .= "Error retrieving payment information!\n";
			debug_message($ps->getLastError());
		}
	}

	if($ps->task_id > 0){
		if($task->get($task_id) === FALSE){
			$error_msg .= "Error getting task information!\n";
			debug_message($task->getLastError());
		}

		if($project->get($task->project_id) === FALSE){
			$error_msg .= "Error getting project information!\n";
			debug_message($project->getLastError());
		}
	}else{
		if($project->get($ps->project_id) === FALSE){
			$error_msg .= "Error getting project information!\n";
			debug_message($project->getLastError());
		}
	}

	if($_POST['save']){
		$_POST['due_ts'] = getDateSelectorTS("due_ts");
		$ps->updateFromAssocArray($_POST);
		if($ps->update()){
			goBack();
		}else{
			$error_msg .= "Error updating Payment Schedule!\n";
			debug_message($ps->getLastError());
		}
	}
}else if($_REQUEST['mode'] == 'delete'){
	$title = "Delete Payment Schedule";

	if(!$ps->get($_REQUEST['id'])){
		$error_msg .= "Error retrieving payment information!\n";
		debug_message($ps->getLastError());
	}

	if($_POST['confirm']){
		if($_POST['confirm'] == "Yes"){
			if($ps->delete($_REQUEST['id'])){
				goBack();
			}else{
				$error_msg .= "Error deleting Payment Schedule!\n";
			}
		}else{
			goBack();
		}
	}
}else{
	fatal_error("Invalid mode ({$_REQUEST['mode']}) for this page!");
}

?>
<? require('header.php'); ?>
<FORM ACTION="<?= $_SERVER['PHP_SELF'] ?>" METHOD="POST">
<INPUT NAME="id" TYPE="hidden" VALUE="<?= $_REQUEST['id'] ?>">
<INPUT NAME="project_id" TYPE="hidden" VALUE="<?= $project->id ?>">
<INPUT NAME="task_id" TYPE="hidden" VALUE="<?= $task->id?>">
<INPUT NAME="mode" TYPE="hidden" VALUE="<?= $_REQUEST['mode'] ?>">
<INPUT NAME="referrer" TYPE="hidden" VALUE="<?= $_REQUEST['referrer'] ?>">
<?if($_REQUEST['mode'] == "delete"){?>
<TABLE BORDER="0" CELLSPACING="0" CELLPADDING="0" CLASS="form_table">
<TR>
	<TD CLASS="form_header_cell"><?= $title ?></TD>
</TR>
<TR>
	<TD CLASS="form_field_cell">
		<BR>Are you sure you want to delete this scheduled payment?<BR><BR>
		<SPAN CLASS="error">CAUTION:</SPAN>This action is irreversible.<BR><BR>
	</TD>
</TR>
<TR>
	<TD CLASS="form_footer_cell">
		<DIV ALIGN="center">
			<INPUT TYPE="submit" CLASS="button" NAME="confirm" VALUE="Yes">&nbsp;&nbsp;
			<INPUT TYPE="submit" CLASS="button" NAME="confirm" VALUE="No">
		</DIV>
	</TD>
</TR>
<?}else{?>
<TABLE BORDER="0" CELLSPACING="0" CELLPADDING="0" CLASS="form_table">
<TR>
	<TD COLSPAN="2" CLASS="form_header_cell"><?= $title ?></TD>
</TR>
<TR>
	<TD CLASS="form_field_header_cell">Project:</TD>
	<TD CLASS="form_field_cell"><?= $project->name?></TD>
</TR>
<TR>
	<TD CLASS="form_field_header_cell">Task:</TD>
	<TD CLASS="form_field_cell"><?= $task->name?></TD>
</TR>
<TR>
	<TD CLASS="form_field_header_cell">Due Date:</TD>
	<TD CLASS="form_field_cell"><?= getDateSelector($ps->due_ts, "due_ts") ?></TD>
</TR>
<TR>
	<TD CLASS="form_field_header_cell">Amount:</TD>
	<TD CLASS="form_field_cell"><INPUT NAME="amount" CLASS="input_text" SIZE="10" TYPE="text" VALUE="<?= $ps->amount ?>"></TD>
</TR>
<TR>
	<TD CLASS="form_field_header_cell">Description:</TD>
	<TD CLASS="form_field_cell"><INPUT NAME="description" CLASS="input_text" SIZE="35" TYPE="text" VALUE="<?= $ps->description ?>"></TD>
</TR>
<TR>
	<TD COLSPAN="2" CLASS="form_field_cell">
		<DIV ALIGN="right"><INPUT TYPE="submit" CLASS="button" NAME="save" VALUE="Save"></DIV>
	</TD>
</TR>	
</TABLE>
<?} //if mode==delete?>
</FORM>
<? require('footer.php'); ?>