<?php
require_once('includes/common.php');
checkLogin('admin');

require_once('includes/User.php');
require_once('includes/Company.php');
require_once('includes/UserType.php');
$title = '';
$user = new User();

// Clean up hourly_rate
if(!empty($_POST['hourly_rate'])){
	$_POST['hourly_rate'] = preg_replace('/[^0-9\.]/','', $_POST['hourly_rate']);
}

// Clean up salary
if(!empty($_POST['salary'])){
	$_POST['salary'] = preg_replace('/[^0-9\.]/','', $_POST['salary']);
}

if($_REQUEST['mode'] == 'add'){
	$title = "Add User";
	
	if($_POST['save']){
		$_POST['password'] = md5($_POST['password']);
		$user->updateFromAssocArray($_POST);
		if($user->add()){
			if($user->updateRights($_POST['rights'])){
				goBack();
			}else{
				$error_msg .= "Error updating user rights!\n";
				debug_message($user->getLastError());	
			}
		}else{
			$error_msg .= "Error adding User!\n";
			debug_message($user->getLastError());
		}		
	}
}else if($_REQUEST['mode'] == 'edit'){
	$title = "Edit User";
	if(empty($_REQUEST['id'])){
		$error_msg .= "Error: No ID specified!\n";
	}else{
		if(!$user->get($_REQUEST['id'])){
			$error_msg .= "Error retrieving user information!\n";
			debug_message($user->getLastError());
		}
	}

	if($_POST['save']){
		if(!empty($_POST['password']))
			$_POST['password'] = md5($_POST['password']);
		else
			unset($_POST['password']);
			
		$user->updateFromAssocArray($_POST);
		if($user->update()){
			if($user->updateRights($_POST['rights'])){
				goBack();
			}else{
				$error_msg .= "Error updating user rights!\n";
				debug_message($user->getLastError());	
			}
		}else{
			$error_msg .= "Error updating User!\n";
			debug_message($user->getLastError());
		}	
	}
}else if($_REQUEST['mode'] == 'delete'){
	$title = "Delete User";
	if($user->delete($_REQUEST['id'])){
		goBack();
	}else{
		$error_msg .= "Error deleting User!\n";
		debug_message($user->getLastError());
	}
}else{
	$title = "Invalid Mode";
	$error_msg .= "Error: Invalid mode!\n";
}

$js_onLoad = "setRateType()";
?>
<?php require('header.php'); ?>
<SCRIPT>
function setRateType(){
	var rate_type = document.user.rate_type.options[document.user.rate_type.selectedIndex].value;
	if(rate_type == 'SALARY'){
		document.user.salary.disabled = false;
		document.user.hourly_rate.disabled = true;
	}else if(rate_type == 'HALF_CUST_RATE'){
		document.user.salary.disabled = true;
		document.user.hourly_rate.disabled = true;
	}else{
		document.user.salary.disabled = true;
		document.user.hourly_rate.disabled = false;
	}
}
</SCRIPT>
<FORM NAME="user" ACTION="<?= $_SERVER['PHP_SELF'] ?>" METHOD="POST">
<INPUT NAME="id" TYPE="hidden" VALUE="<?= $_REQUEST['id'] ?>">
<INPUT NAME="mode" TYPE="hidden" VALUE="<?= $_REQUEST['mode'] ?>">
<INPUT NAME="referrer" TYPE="hidden" VALUE="<?= $_REQUEST['referrer'] ?>">
<TABLE BORDER="0" CELLSPACING="0" CELLPADDING="0" CLASS="form_table">
<TR>
	<TD COLSPAN="2" CLASS="form_header_cell"><?= $title ?></TD>
</TR>
<TR>
	<TD CLASS="form_field_header_cell">First Name:</TD>
	<TD CLASS="form_field_cell"><INPUT NAME="first_name" CLASS="input_text" SIZE="25" TYPE="text" VALUE="<?= $user->first_name ?>"></TD>
</TR>
<TR>
	<TD CLASS="form_field_header_cell">Last Name:</TD>
	<TD CLASS="form_field_cell"><INPUT NAME="last_name" CLASS="input_text" SIZE="25" TYPE="text" VALUE="<?= $user->last_name ?>"></TD>
</TR>
<TR>
	<TD CLASS="form_field_header_cell">Company:</TD>
	<TD CLASS="form_field_cell">
		<SELECT NAME="company_id" CLASS="input_text">
			<?= Company::getSelectTags($user->company_id) ?>
		</SELECT>
	</TD>
</TR>
<TR>
	<TD CLASS="form_field_header_cell">Address Line 1:</TD>
	<TD CLASS="form_field_cell"><INPUT NAME="address1" CLASS="input_text" SIZE="35" TYPE="text" VALUE="<?= $user->address1 ?>"></TD>
</TR>
<TR>
	<TD CLASS="form_field_header_cell">Address Line 2:</TD>
	<TD CLASS="form_field_cell"><INPUT NAME="address2" CLASS="input_text" SIZE="35" TYPE="text" VALUE="<?= $user->address2 ?>"></TD>
</TR>
<TR>
	<TD CLASS="form_field_header_cell">City:</TD>
	<TD CLASS="form_field_cell"><INPUT NAME="city" CLASS="input_text" SIZE="35" TYPE="text" VALUE="<?= $user->city ?>"></TD>
</TR>
<TR>
	<TD CLASS="form_field_header_cell">State:</TD>
	<TD CLASS="form_field_cell"><INPUT NAME="state" CLASS="input_text" SIZE="5" TYPE="text" VALUE="<?= $user->state ?>"></TD>
</TR>
<TR>
	<TD CLASS="form_field_header_cell">Zip:</TD>
	<TD CLASS="form_field_cell"><INPUT NAME="zip" CLASS="input_text" SIZE="10" TYPE="text" VALUE="<?= $user->zip ?>"></TD>
</TR>
<TR>
	<TD CLASS="form_field_header_cell">E-Mail:</TD>
	<TD CLASS="form_field_cell"><INPUT NAME="email" CLASS="input_text" SIZE="35" TYPE="text" VALUE="<?= $user->email ?>"></TD>
</TR>
<TR>
	<TD CLASS="form_field_header_cell">Password:</TD>
	<TD CLASS="form_field_cell"><INPUT NAME="password" CLASS="input_text" SIZE="20" TYPE="text" VALUE=""></TD>
</TR>
<TR>
	<TD CLASS="form_field_header_cell">Rate Type:</TD>
	<TD CLASS="form_field_cell">
		<SELECT NAME="rate_type" CLASS="input_text" onchange="setRateType()">
			<?= User::getRateTypeSelectTags($user->rate_type) ?>
		</SELECT>
	</TD>
</TR>
<TR>
	<TD CLASS="form_field_header_cell">Annual Salary:</TD>
	<TD CLASS="form_field_cell"><INPUT NAME="salary" CLASS="input_text" SIZE="10" TYPE="text" VALUE="<?= $user->salary ?>"></TD>
</TR>
<TR>
	<TD CLASS="form_field_header_cell">Hourly Rate:</TD>
	<TD CLASS="form_field_cell"><INPUT NAME="hourly_rate" CLASS="input_text" SIZE="10" TYPE="text" VALUE="<?= $user->hourly_rate ?>"></TD>
</TR>
<TR>
	<TD CLASS="form_field_header_cell">Receive Invoices?</TD>
	<TD CLASS="form_field_cell">
		<INPUT NAME="invoiced" TYPE="radio" VALUE="Y" <?= checked($user->invoiced, "Y") ?>>Yes&nbsp;
		<INPUT NAME="invoiced" TYPE="radio" VALUE="N" <?= checked($user->invoiced, "N") ?>>No&nbsp;
	</TD>
</TR>
<TR>
	<TD CLASS="form_field_header_cell">Active:</TD>
	<TD CLASS="form_field_cell">
		<INPUT NAME="active" TYPE="radio" VALUE="Y" <?= checked($user->active, "Y") ?>>Yes&nbsp;
		<INPUT NAME="active" TYPE="radio" VALUE="N" <?= checked($user->active, "N") ?>>No&nbsp;
	</TD>
</TR>
<TR>
	<TD CLASS="form_field_header_cell">Type of User:</TD>
	<TD CLASS="form_field_cell">
		<SELECT NAME="user_type_id" CLASS="input_text">
			<?= UserType::getSelectTags($user->user_type_id) ?>
		</SELECT>
	</TD>
</TR>
<TR>
	<TD CLASS="form_field_header_cell">User Rights:</TD>
	<TD CLASS="form_field_cell">
		<input type="checkbox" name="rights[admin]" value="1" <?= $user->hasRight('admin') ? 'CHECKED' : '' ?>/>&nbsp;Administrative Access<BR>
		<input type="checkbox" name="rights[accounting]" value="1" <?= $user->hasRight('accounting') ? 'CHECKED' : '' ?>/>&nbsp;Accounting Access<BR>  
	</TD>
</TR>
<TR>
	<TD CLASS="form_field_header_cell">Created On:</TD>
	<TD CLASS="form_field_cell"><?= $user->created_ts ? date("D M jS, Y \a\\t h:i:s A", $user->created_ts) : "" ?></TD>
</TR>
<TR>
	<TD CLASS="form_field_header_cell">Last Updated:</TD>
	<TD CLASS="form_field_cell"><?= $user->updated_ts ? date("D M jS, Y \a\\t h:i:s A", $user->updated_ts) : "" ?></TD>
</TR>
<TR>
	<TD CLASS="form_field_header_cell">Last Login:</TD>
	<TD CLASS="form_field_cell"><?= $user->last_login_ts ? date("D M jS, Y \a\\t h:i:s A", $user->last_login_ts) : "" ?></TD>
</TR>
<TR>
	<TD COLSPAN="2" CLASS="form_field_cell">
		<DIV ALIGN="right"><INPUT TYPE="submit" CLASS="button" NAME="save" VALUE="Save"></DIV>
	</TD>
</TR>	
</TABLE>
</FORM>
<? require('footer.php'); ?>